#! /usr/bin/perl
#
# wanha - your pesky URL-guardian for IRC
# Copyright (C) 2006-2007 Tommi Saviranta  <wnd@iki.fi>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


use strict;
use warnings FATAL => 'all';
use diagnostics;

use Wanha::HTML;
use Wanha::HTTP;
use Wanha::Link;
use Wanha::Chan;
use Wanha::Nick;


=item main
Main function
=cut
sub main() {
	my $search = &Wanha::HTTP::get("s", undef);

	defined($search) || &redir(&Wanha::Link::chan(-1));

	# Assume non-'#'-starting users
	if (! ($search =~ /^#/ || $search =~ /^!/ || $search =~ /^&/)) {
		my $user = &Wanha::Nick::get_id($search);
		defined($user) && &redir(&Wanha::Link::user($user));

		# Assume channel name without a '#' if no nick was found
		$search = "#$search";
	}

	my $chan = &Wanha::Chan::get_id($search);
	defined($chan) || &redir(&Wanha::Link::chan(-1));
	&redir(&Wanha::Link::chan($chan));
}


=item redir
Redirect to given URL

0: url
=cut
sub redir($) {
	my ($url) = @_;
	my $location = &Wanha::Config::base_url() . "/";
	$location =~ s/\/\//\//g;
	$location =~ s/:\/([^\/])/:\/\/$1/;
	$url = "chan.pl" if (! defined($location));
	$location = "$location$url";
	&Wanha::HTTP::redirect($location);
	&Wanha::HTTP::print_header();
	&Wanha::HTML::print_header($location);
	print <<EOF;
<p>
Go to <a href="$location">$location</a>.
</p>

EOF
	&Wanha::HTML::print_footer();
	exit(0);
}


&main();
exit(0);
